//
//  AddBookmarkViewController.m
//  MerckManual
//
//  Created by Brian Pfeil on 3/31/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "AddBookmarkViewController.h"
#import "BookmarkManager.h"

@implementation AddBookmarkViewController

@synthesize tableView=_tableView;
@synthesize bookmarkNameTextField=_bookmarkNameTextField;
@synthesize currentItem=_currentItem;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	self.navigationItem.rightBarButtonItem = [[UIBarButtonItem alloc] initWithTitle:@"Save" style:UIBarButtonItemStyleDone target:self action:@selector(save:)];	
	[self initBookmarkNameTextField];
}


- (void)viewWillAppear:(BOOL)animated {
	[super viewWillAppear:animated];
	[self updateBookmarkNameWithCurrentItem];
}

- (void)initBookmarkNameTextField {
	self.bookmarkNameTextField = [[UITextField alloc] initWithFrame:CGRectMake(10,10,305,22)];
	self.bookmarkNameTextField.delegate = self;
	self.bookmarkNameTextField.keyboardType = UIKeyboardTypeDefault;
	self.bookmarkNameTextField.returnKeyType = UIReturnKeyDone;
	self.bookmarkNameTextField.clearButtonMode = UITextFieldViewModeWhileEditing;
	self.bookmarkNameTextField.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;
	self.bookmarkNameTextField.contentVerticalAlignment = UIControlContentVerticalAlignmentCenter;
	self.bookmarkNameTextField.font = [UIFont boldSystemFontOfSize:15.0];
	self.bookmarkNameTextField.textColor = [UIColor blackColor];	
}

- (void)updateBookmarkNameWithCurrentItem {
	NSDictionary *item = [[_currentItem valueForKey:@"paras"] objectAtIndex:0];
	NSString *chapterName = [item valueForKey:@"chapter_name"];
	NSString *topicName = [item valueForKey:@"topic_name"];
	NSString *bookmarkName = [NSString stringWithFormat:@"%@: %@", chapterName, topicName];
	self.bookmarkNameTextField.text = bookmarkName;
	[self.bookmarkNameTextField becomeFirstResponder];
}



// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    //return (interfaceOrientation == UIInterfaceOrientationPortrait);
	return YES;
}

- (void)didRotateFromInterfaceOrientation:(UIInterfaceOrientation)fromInterfaceOrientation {
	[super didRotateFromInterfaceOrientation:fromInterfaceOrientation];
	[self updateBookmarkNameWithCurrentItem];
}


- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	return 1;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	static NSString *cellId = @"cellid";
	UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellId];
	if (!cell) {
		cell = [[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:cellId];
	}
	
	[self updateBookmarkNameWithCurrentItem];
	[self.bookmarkNameTextField becomeFirstResponder];
	[cell.contentView addSubview:self.bookmarkNameTextField];
	
	return cell;
}

- (void)save:(id)sender {
	NSString *bookmarkName = _bookmarkNameTextField.text;
	NSDate *dateAdded = [NSDate date];
	
	[[BookmarkManager sharedInstance] addBookmarkNamed:bookmarkName forItem:_currentItem forDate:dateAdded];
	[self.navigationController dismissModalViewControllerAnimated:YES];
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField {
	[self save:self];
	return YES;
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}


@end
