//
//  TOCViewController.m
//  MerckManual
//
//  Created by Brian Pfeil on 3/26/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "BookmarksViewController.h"
#import "DataTableViewCell.h"


@implementation BookmarksViewController

@synthesize tableView=_tableView;
@synthesize content=_content;

 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {

    }
    return self;
}


/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}
*/

- (void)viewWillAppear:(BOOL)animated {
	[super viewWillAppear:animated];
	[_tableView reloadData];
	
}

- (void)didRotateFromInterfaceOrientation:(UIInterfaceOrientation)fromInterfaceOrientation {
	[super didRotateFromInterfaceOrientation:fromInterfaceOrientation];
	[self updateUI];
}

- (void)updateUI {
	[_tableView reloadData];
}


// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    //return (interfaceOrientation == UIInterfaceOrientationPortrait);
	return YES;
}

//- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
//	return 0;
//}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	return [_content count];
}

//- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {
//	return @"";
//}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	static NSString *cellID = @"cellid";
	DataTableViewCell *cell = (DataTableViewCell*)[tableView dequeueReusableCellWithIdentifier:cellID];
	if (!cell) {
		cell = [[DataTableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:cellID];
		cell.font = [UIFont boldSystemFontOfSize:14];
		cell.image = [UIImage imageNamed:@"bookmark.png"];
	}

	NSDictionary *item = [_content objectAtIndex:indexPath.row];
	cell.text = [item valueForKey:@"bookmark_name"];

	
//	if (indexPath.section == 0 && indexPath.row == 0) {
//		cell.textLabel.text = @"Home";
//		cell.accessoryType = UITableViewCellAccessoryNone;
//	} else {
//		NSDictionary *data = [_content objectAtIndex:indexPath.row];
//		NSString *type = [data valueForKey:@"type"];
//		cell.data = data;
//		
//		if ([type isEqualToString:@"para"]) {
//			NSString *title = [data valueForKey:@"title"];
//			cell.textLabel.text = title ? title : @"no title";
//		} else {
//			cell.textLabel.text = [data valueForKey:@"name"];
//		}
//		
//		if (! ([type isEqualToString:@"topic"] || [type isEqualToString:@"para"]) ) {
//			cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
//		} else {
//			cell.accessoryType = UITableViewCellAccessoryNone;
//		}
//		
//	}
	
	return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
//	if (indexPath.section == 0) {
//		_content = [Content sharedInstance].content;
//		_currentItem = nil;
//		self.title = @"Contents";
//		//[self.navigationItem.leftBarButtonItem setHidesBackButton:YES animated:YES];
//		_sectionHeaderName = @"Sections";
//		[_tableView reloadData];
//		return;
//	} else {
//		DataTableViewCell *cell = (DataTableViewCell*)[tableView cellForRowAtIndexPath:indexPath];
//		NSDictionary *data = (NSDictionary*)cell.data;
//		NSString *type = [data valueForKey:@"type"];
//		NSString *name = [data valueForKey:@"name"];
//		
//		TOCViewController *vc = [[TOCViewController alloc] initWithNibName:@"TOCView" bundle:nil];
//		vc.navigationItem.rightBarButtonItem = [[UIBarButtonItem alloc] initWithTitle:@"Cancel" style:UIBarButtonItemStylePlain target:[UIApplication sharedApplication].delegate action:@selector(cancelView:)];	
//		
//		if ([type isEqualToString:@"section"]) {
//			vc.content = [data valueForKey:@"chapters"];
//			vc.title = @"Chapters";
//			vc.sectionHeaderName = [NSString stringWithFormat:@"%@", name];
//			[self.navigationController pushViewController:vc animated:YES];
//		} else if ([type isEqualToString:@"chapter"]) {
//			vc.content = [data valueForKey:@"topics"];
//			vc.title = @"Topics";			
//			vc.sectionHeaderName = [NSString stringWithFormat:@"%@", name];
//			[self.navigationController pushViewController:vc animated:YES];			
//		} else if ([type isEqualToString:@"topic"]){
//			[[UIApplication sharedApplication].delegate performSelector:@selector(nav:) withObject:data];
//			[self.navigationController dismissModalViewControllerAnimated:YES];
//		} else {
//		}
//	}
	
	NSDictionary *item = [_content objectAtIndex:indexPath.row];
	
	[[UIApplication sharedApplication].delegate performSelector:@selector(nav:) withObject:item];
	[self.navigationController dismissModalViewControllerAnimated:YES];
	
	[tableView deselectRowAtIndexPath:indexPath animated:YES];	
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}


@end
