//
//  Config.m
//  MerckManual
//
//  Created by Brian Pfeil on 3/27/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "Config.h"
#import "JSON.h"

static NSString* const configFileName = @"config.json";

@implementation Config

- (void)dealloc {
	[_config release];
	[super dealloc];
}

- (id)init {
	if(self = [super init]) {
		[self initConfig];
	}
	return self;
}

+ (Config*)sharedInstance {
	static Config *sharedInstance = nil;
	if (!sharedInstance) {
		sharedInstance = [[Config alloc] init];
	}
	return sharedInstance;
}

- (void)initConfig {
	NSString *bundlePath = [[NSBundle mainBundle] bundlePath];
	NSString *configFilePath = [bundlePath stringByAppendingPathComponent:configFileName];
	NSString *configDataString = [NSString stringWithContentsOfFile:configFilePath];
	_config = (NSMutableDictionary*)[[configDataString JSONValue] retain];
}

- (id)valueForKeyPath:(NSString*)key {
	return [_config valueForKeyPath:key];
}

- (NSString*)stringForKeyPath:(NSString*)key {
	return (NSString*)[self valueForKeyPath:key];
}
@end
