//
//  MerckManualAppDelegate.h
//  MerckManual
//
//  Created by Brian Pfeil on 3/26/09.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "DisclaimerViewController.h"
#import "AddBookmarkViewController.h"
#import "BookmarksViewController.h"
#import "TOCViewController.h"
#import "SearchViewController.h"
#import "NavigationHistory.h"

@class MerckManualViewController;

@interface MerckManualAppDelegate : NSObject <UIApplicationDelegate,UIWebViewDelegate> {
    UIWindow *window;
	UINavigationController *_navigationController;
	DisclaimerViewController *_disclaimerViewController;
    MerckManualViewController *_merckManualViewController;
	AddBookmarkViewController *_addBookmarkViewController;
	BookmarksViewController *_bookmarksViewController;
	TOCViewController *_tocViewController;
	SearchViewController *_searchViewController;
	
	UIActivityIndicatorView *_toolbarActivityIndicator;
	UILabel *_activityLabel;
	UIToolbar *_toolbar;
	UIBarButtonItem *_activityIndicatorButton;
	UIBarButtonItem *_activityLabelButton;
	UIBarButtonItem *_backButton;
	UIBarButtonItem *_forwardButton;	
	UIBarButtonItem *_addButton;
	UIBarButtonItem *_bookmarkButton;
	UIBarButtonItem *_tocButton;	
	UIBarButtonItem *_searchButton;	
	
	NavigationHistory *_navHist;
}

@property (nonatomic, retain) IBOutlet UIWindow *window;
@property (nonatomic, retain) IBOutlet UINavigationController *navigationController;
@property (nonatomic, retain) IBOutlet DisclaimerViewController *disclaimerViewController;
@property (nonatomic, retain) IBOutlet MerckManualViewController *merckManualViewController;
@property (nonatomic, retain) IBOutlet AddBookmarkViewController *addBookmarkViewController;
@property (nonatomic, retain) IBOutlet BookmarksViewController *bookmarksViewController;
@property (nonatomic, retain) IBOutlet TOCViewController *tocViewController;
@property (nonatomic, retain) IBOutlet SearchViewController *searchViewController;

@property (nonatomic, retain) UIActivityIndicatorView *toolbarActivityIndicator;
@property (nonatomic, retain) UILabel *activityLabel;
@property (nonatomic, retain) UIToolbar *toolbar;


- (void)initNavigationController;
- (void)initToolbar;
- (void)initDisclaimerView;
- (void)initMerckManualView;
- (void)initAddBookmarkView;
- (void)initBookmarksView;
- (void)initTOCView;
- (void)initSearchView;

- (void)enableNavigation:(BOOL)enabled;
- (void)nav:(id)item;
- (void)navDisclaimer:(id)sender;
- (void)navAddBookmark:(id)sender;
- (void)navBookmarks:(id)sender;
- (void)navTOC:(id)sender;
- (void)navSearch:(id)sender;

- (void)displayTopicPage:(NSDictionary*)topic;

- (void)updateNavigation;

@end

